import { Button, Popup } from "vant";
import { } from "vant";
import { defineComponent, nextTick, onMounted, onUnmounted, reactive, ref, watch } from "vue";
import styles from "./index.module.less";
import { getImage } from "./images";
import {getGuidance,setGuidance} from './api'
export default defineComponent({
  name: "courseware-detail",
  emits: ["close","changeShowGuide"],
  setup(props, { emit,}) {
    const data = reactive({
      box: {},
      show: false,
      steps: [
        {
          ele: "",
          eleRect: {} as DOMRect,
          img: getImage("courseware-detail1.png"),
          handStyle: {
            top: "-0.4rem",
            left:"0.98rem",
            transform: 'rotate(-90deg)'
          },
          boxStyle:{
            'borderRadius':'0.1rem'
					},
          imgStyle: {
            top: "-1.3rem",
            left:"2.2rem",
          },
          btnsStyle: {
            top: "1.5rem",
            left:"3.5rem",
          },
        },

      ],
      step: 0,
    });
    const tipShow = ref(false)

    const guideInfo = ref({} as any)
    console.log('调用')
    // setGuidance({guideTag:'guideInfo',guideValue:'{}'})

    const getAllGuidance = async()=>{
      try{
        const res = await getGuidance({guideTag:'guideInfo'})
        if(res.data){
          guideInfo.value = JSON.parse(res.data?.guideValue) || null
        }else{
          guideInfo.value = {}
        }
        if (guideInfo.value &&guideInfo.value.coursewareDetail) {

          tipShow.value = false;
          emit('changeShowGuide',tipShow.value)

        } else {
          tipShow.value = true;
        }
      }catch(e){
        console.log(e)
      }
      // const guideInfo = localStorage.getItem('teacher-guideInfo');

    }
    watch(()=>tipShow.value,(value)=>{
      emit('changeShowGuide',tipShow.value)
    },{
    })
    getAllGuidance()
  //  const guideInfo = localStorage.getItem('guideInfo')
  //  if(guideInfo&&JSON.parse(guideInfo).coursewareDetail){
  //   tipShow.value =false
  //  }else {
  //   tipShow.value =true
  //  }
    const getStepELe = () => {

      const ele: HTMLElement = document.getElementById(`coursewareDetail-${data.step}`)!;
      if (ele) {
        const eleRect = ele.getBoundingClientRect();
        data.box = {
          left: eleRect.x + "px",
          top: eleRect.y + "px",
          width: eleRect.width + "px",
          height: eleRect.height + "px",
        };
      }else{
        handleNext()
      }
    };
    onMounted(() => {
      getStepELe();
      window.addEventListener("resize", resetSize);
    });
    const resetSize = ()=>{
      getStepELe();
    }

    onUnmounted(()=>{
      window.removeEventListener("resize", resetSize);
    })

    const handleNext = () => {

      if (data.step >= 0) {
       endGuide();
        return;
      }
      data.step = data.step + 1;
      getStepELe();
    };

    const endGuide = async()=>{
      // console.log(`handleNext-${data.step}`)
      // if(!tipShow.value){
      //   return
      // }
      // let guideInfo = JSON.parse(localStorage.getItem('guideInfo')|| '{}') || null
      if(!guideInfo.value){
        guideInfo.value = {coursewareDetail:true}
      }else{
        guideInfo.value.coursewareDetail = true
      }

      try{
        const res = await setGuidance({guideTag:'guideInfo',guideValue:JSON.stringify(guideInfo.value)})
      }catch(e){
        console.log(e)
      }
      console.log('调用detail完成')
      tipShow.value = false
    //  localStorage.setItem('endC')
    }
    return () => (<>
      {tipShow.value?  <Popup teleport="body" overlay={false} closeOnClickOverlay={false} class={["popup-custom", styles.guidePopup]} v-model:show={tipShow.value}>
      <div class={styles.content} onClick={() => handleNext()}>
      {data.step!=data.steps.length-1&&<div
          class={styles.backBtn}
          onClick={(e: Event) => {
            e.stopPropagation();
           endGuide()
          }}
        >

          跳过
        </div>}
        <div class={styles.box} style={{...data.box,...data.steps[data.step]?.boxStyle}} id={`modeType-${data.step}`}>
          {data.steps.map((item: any, index) => (

            <div
              onClick={(e: Event) => e.stopPropagation()}
              class={styles.item}
              style={{
                display: index === data.step ? "" : "none",
                left: `${item.eleRect?.left}px`,
                top: `${item.eleRect?.top}px`,
              }}
            >
              <img class={styles.img} style={item.imgStyle} src={item.img} />
              <img class={styles.iconHead} style={item.handStyle} src={getImage("indexDot.png")} />
              <div class={styles.btns} style={item.btnsStyle}>
                {data.step + 1 == data.steps.length ? (
                  <>
                    {/* <Button
                      class={styles.btn}
                      round
                      color="transparent"
                      style={{ "border-color": "#fff" }}
                      type="primary"
                      onClick={() => {
                        data.step = 0;
                        getStepELe();
                      }}
                    >
                      再看一遍
                    </Button> */}
                    <Button class={[styles.btn,styles.endBtn]} round type="primary" onClick={() =>endGuide()}>
                      完成
                    </Button>
                  </>
                ) : (
                  <Button class={styles.btn} round type="primary" onClick={() => handleNext()}>

                    下一步 ({data.step + 1}/{data.steps.length})
                  </Button>
                )}
              </div>
            </div>
          ))}
        </div>
      </div>
      </Popup>:null}
      </>
    );
  },
});
